#include "global.h"


#define energybary   shipstatusy + 2 * letheight
#define enginebary  shipstatusy + 3 * letheight
#define hullbary    shipstatusy + 4 * letheight
#define shieldbary  shipstatusy + 5 * letheight
#define cloakbary  shipstatusy + 6 * letheight
#define weaponbary  shipstatusy + 7 * letheight

#define scanstatusy weaponbary + 1 * letheight
#define scanenergybary   scanstatusy + 2 * letheight
#define scanenginebary  scanstatusy + 3 * letheight
#define scanhullbary    scanstatusy + 4 * letheight
#define scanshieldbary  scanstatusy + 5 * letheight
#define scancloakbary  scanstatusy + 6 * letheight
#define scanweaponbary  scanstatusy + 7 * letheight

  extern int letheight,maxbar,barheight;
  extern int rightborder,LASTPLAYER,longrangewidth,longrangeheight;
  extern int shapesize[LASTSHAPE+1];
  extern DeviceType device[MAXPLAYERS+1];
  extern ShipType ship[MAXPLAYERS+1];
  extern PhysicalType physical[MAXPLAYERS+1];
  extern Display *dpys[MAXPLAYERS + 1]; 
  extern Objtype obj[LASTOBJ+1];
  extern VirtualType virtual;

/*****************************************************************************/

/* This function will draw all of the static objects to the passed player's 
   display. 
   The static objects include :  
     The border around the long range scan
     The lines in between the ship status and scanned ship windows. 
     The text that appears in the ship status and and scanned ship status 
     windows.

*/

DrawStaticObjects(xdisplay,player)  /* Print status line text */
     Xparam xdisplay;
     int player;

{ 
  
  char text[70];
  int textx = device[player].width + 5;
  GC gc = xdisplay->gc;
  XPoint figure[5];

  /* Draw the border around the long range scan */
  figure[0].x = 1;
  figure[0].y = 1;
  
  figure[1].x = device[player].width+1;
  figure[1].y = figure[0].y;
  
  figure[2].x = figure[1].x;
  figure[2].y = device[player].height-1;
  
  figure[3].x = figure[0].x;
  figure[3].y = figure[2].y;
  
  figure[4].x = figure[0].x;
  figure[4].y = figure[0].y;
  
  XDrawLines(xdisplay->disp, xdisplay->window, xdisplay->gc,figure,5,CoordModeOrigin);
  
  /* Draw the lines between the ship status and scanned ship windows */
  figure[0].x = device[player].width;
  figure[0].y = shipstatusy;
  
  figure[1].x = device[player].width + rightborder;
  figure[1].y = figure[0].y;
  XDrawLines(xdisplay->disp, xdisplay->window, xdisplay->gc,figure,2,CoordModeOrigin);
  
  figure[0].x = device[player].width;
  figure[0].y = scanstatusy;
  
  figure[1].x = device[player].width + rightborder;
  figure[1].y = figure[0].y;
  XDrawLines(xdisplay->disp, xdisplay->window, xdisplay->gc,figure,2,CoordModeOrigin);

  /* Draw the text requried for the status and scan windows */
  sprintf(text, "     Scanned Ship");
  XDrawImageString (xdisplay->disp, xdisplay->window, 
                    xdisplay->gc,textx,scanstatusy + letheight,
                    text, strlen(text));


  sprintf(text, "     Ship Status");
  XDrawImageString (xdisplay->disp, xdisplay->window, 
                    xdisplay->gc,textx,shipstatusy + letheight,
                    text, strlen(text));

  sprintf(text, "Engines:");
  XDrawImageString (xdisplay->disp, xdisplay->window, 
                    xdisplay->gc,textx,enginebary + barheight,
                    text, strlen(text));

  sprintf(text, "Hull   :");
  XDrawImageString (xdisplay->disp, xdisplay->window, 
                    xdisplay->gc,textx,hullbary + barheight,
                    text, strlen(text));

  sprintf(text, "Energy :");
  XDrawImageString (xdisplay->disp, 
                    xdisplay->window, xdisplay->gc,textx,energybary + barheight,
                    text, strlen(text));

  sprintf(text, "Shields:");
  XDrawImageString (xdisplay->disp, 
                    xdisplay->window, xdisplay->gc,textx,shieldbary + barheight,
                    text, strlen(text));

  sprintf(text, "Cloak  :");
  XDrawImageString (xdisplay->disp
                    , xdisplay->window, xdisplay->gc,textx,cloakbary + barheight,
                    text, strlen(text));

  sprintf(text, "Weapons:");
  XDrawImageString (xdisplay->disp, 
                    xdisplay->window, xdisplay->gc,textx,weaponbary + barheight,
                    text, strlen(text));

  sprintf(text, "Engines:");
  XDrawImageString (xdisplay->disp,
                    xdisplay->window, 
                    xdisplay->gc,textx,scanenginebary + barheight,
                    text, strlen(text));

  sprintf(text, "Hull   :");
  XDrawImageString (xdisplay->disp, 
                    xdisplay->window, 
                    xdisplay->gc,textx,scanhullbary + barheight,
                    text, strlen(text));

  sprintf(text, "Energy :");
  XDrawImageString (xdisplay->disp, 
                    xdisplay->window, 
                    xdisplay->gc,textx,scanenergybary + barheight,
                    text, strlen(text));

  sprintf(text, "Shields:");
  XDrawImageString (xdisplay->disp, 
                    xdisplay->window, 
                    xdisplay->gc,textx,scanshieldbary + barheight,
                    text, strlen(text));

  sprintf(text, "Cloak  :");
  XDrawImageString (xdisplay->disp, 
                    xdisplay->window, 
                    xdisplay->gc,textx,scancloakbary + barheight,
                    text, strlen(text));

  sprintf(text, "Weapons:");
  XDrawImageString (xdisplay->disp, 
                    xdisplay->window, 
                    xdisplay->gc,textx,scanweaponbary + barheight,
                    text, strlen(text));



 
}
/*****************************************************************************/
 /* This function will return the graphics context associated with the passed 
    values */
GC GetBarGC (xdisplay,val, maxval)
  int val,maxval;
  Xparam xdisplay;
  
{
  double d = (double)val/(double)maxval;
  if (d > 0.99) return xdisplay->greengc;
  if (d > 0.25) return xdisplay->yellowgc;
  return xdisplay->redgc;
}

/*****************************************************************************/
/* This function will draw a bar based on the passed values.  The bar consists of
   two rectangles, one that is the actual bar that is show to the user and the 
   other is the area that area that is left over from the previous bar. 
*/
showbar(player,xdisplay,val,maxval,bary)
int player,val,maxval,bary;
  Xparam xdisplay;
{

  int barx = device[player].width + 65;

#define STATUSBARS
#ifdef STATUSBARS
 int barval;
  double d = (double)val/(double)maxval * (double)maxbar;   
  barval = (int) d;

/*DD  printf("varx %i height%i barval%i barheight %i\n",barx, bary,barval, barheight);
*/

  XFillRectangle(xdisplay->disp, xdisplay->window, 
                 GetBarGC(xdisplay,val,maxval), barx, bary,
                 barval, barheight);
  if (barval < maxbar) {
    XClearArea(xdisplay->disp, 
               xdisplay->window, barx+barval, 
               bary, maxbar-barval, barheight, False);
  }

#else
  /* Show the percentage of system damage via text output */
  char text[70];
  int ival;

  barx = barx + 5;

  ival = (int)((float)val/(float)maxval * 100.0);
  sprintf(text, "%i  ",ival);

  XClearArea(xdisplay->disp, 
               xdisplay->window, barx, 
               bary, 80, barheight, False);

/*  XFillRectangle(xdisplay->disp, xdisplay->window, 
                 GetBarGC(xdisplay,val,maxval), barx, bary,
                 80, barheight);
*/
  XDrawImageString (xdisplay->disp, xdisplay->window, 
                    GetBarGC(xdisplay,val,maxval),
                    barx,bary,
                    text, strlen(text));

#endif;
}


/*****************************************************************************/
/* This procedure will draw the dynamic portions of the ship status and
   scanned ship windows. There are is a call to the function show bar for
   each of the ships' statuses */

DrawShipStatus(player,xdisplay)  
        Xparam xdisplay;
        int player;
{ extern int height;
  extern Objtype obj[LASTOBJ+1];   
  char sstring[30];
  int barval;
  char text[70];

  /* Draw energy bar  */

  showbar(player,xdisplay,obj[player].energy,ship[player].initialenergy,energybary);

  /* Draw shield shield bar */


  showbar(player,xdisplay,ship[player].system[shieldsys].
          hitpoints,ship[player].system[shieldsys].maxhitpoints,shieldbary);

  /* Draw cloak cloak bar */


  showbar(player,xdisplay,ship[player].system[cloaksys].hitpoints,
          ship[player].system[cloaksys].maxhitpoints,cloakbary);


  showbar(player,xdisplay,ship[player].system[enginesys].hitpoints,
          ship[player].system[enginesys].maxhitpoints,enginebary);





  showbar(player,xdisplay,ship[player].system[weaponsys].hitpoints,
          ship[player].system[weaponsys].maxhitpoints,weaponbary);




  showbar(player,xdisplay,ship[player].system[hullsys].hitpoints,
          ship[player].system[hullsys].maxhitpoints,hullbary);
 
  /* Draw the scanned ship status if this ship is scanning another */
  if (ship[player].scannedship != NOSHIP) {
    int scannedship = ship[player].scannedship;
    
    showbar(player,xdisplay,obj[scannedship].energy,
            ship[scannedship].initialenergy,scanenergybary);
    
    showbar(player,xdisplay,ship[scannedship].system[shieldsys].hitpoints,
            ship[scannedship].system[shieldsys].maxhitpoints,scanshieldbary);

    showbar(player,xdisplay,ship[scannedship].system[cloaksys].hitpoints,
            ship[scannedship].system[cloaksys].maxhitpoints,scancloakbary);

    showbar(player,xdisplay,ship[scannedship].system[enginesys].hitpoints,
            ship[scannedship].system[enginesys].maxhitpoints,scanenginebary);  

    showbar(player,xdisplay,ship[scannedship].system[hullsys].hitpoints,
            ship[scannedship].system[hullsys].maxhitpoints,scanhullbary);

    showbar(player,xdisplay,ship[scannedship].system[weaponsys].hitpoints,
            ship[scannedship].system[weaponsys].maxhitpoints,scanweaponbary);



  }

        

}

/*****************************************************************************/

/* This function will draw the long range scan for the passed player */
DrawLongRangeScan (xdisplay,player) 
     Xparam xdisplay[MAXPLAYERS+1];
     int player;

{  int i,rx,ry,size,drawit,line;
   XPoint figure[MAXPAIRS];
   GC gc;
  extern PolarPair shapes[LASTSHAPE+1][MAXPAIRS];
  extern int numpairs[LASTSHAPE+1];

   /* Draw the lines that shows the range of the short range scan */
   figure[0].x = (int)((physical[player].x * device[player].longrangescalex ));
   figure[0].y = (int)(physical[player].y * device[player].longrangescaley);

   figure[1].x = (int)((physical[player].x + physical[player].width) * 
                       device[player].longrangescalex);
   figure[1].y = figure[0].y;
   
   figure[2].x = figure[1].x;
   figure[2].y = (int)((physical[player].y + physical[player].height) * 
                       device[player].longrangescaley);

   figure[3].x = figure[0].x;
   figure[3].y = figure[2].y;

   figure[4].x = figure[0].x;
   figure[4].y = figure[0].y;
   XDrawLines(xdisplay[player]->disp, xdisplay[player]->lrpixmap, 
              xdisplay[player]->gc,
              figure,5,CoordModeOrigin);   

   /* Draw all of the objects that appear in the long range scan. */
   for (i = FIRSTPLAYER; i <= LASTAST; i++) {

     if (obj[i].alive){  
       if ( i <= MAXPLAYERS ) {
         drawit = 1;
         if (i == player) {
           if (ship[i].cloak_on) {
             gc = xdisplay[player]->cloakgc;
           }
           else {
             gc = xdisplay[player]->greengc;
           }
          
         }
         else {
           if (ship[i].cloak_on) {
             gc = xdisplay[player]->pmgc;
             drawit = 0;
           }
           else {
             gc = xdisplay[player]->yellowgc; 

           }
         }

         size = ship[i].size;
     
       }
       else {
         if (obj[i].shape == ASTSHAPE1) {
           drawit = 1;

           size = (double)shapesize[ASTSHAPE1]; 
           gc = xdisplay[player]->redgc;  
         }
         else {
           drawit = 0;
         }
       }

       if (drawit) {
/*         rx = (int) (((double) obj[i].x - size)*device[player].longrangescalex);
         ry = (int) (((double) obj[i].y - size)*device[player].longrangescaley);

         size = size * device[player].longrangescalex;

         XDrawArc(xdisplay[player]->disp, xdisplay[player]->lrpixmap, gc,
                  rx,
                  ry,
                  size, size, 0, 360*64);
*/

         figure[0].x = (int) (obj[i].x ) * 
                              device[player].longrangescalex ;
         figure[0].y = (int) (obj[i].y)* 
                              device[player].longrangescaley ;

         for (line=1; line < numpairs[obj[i].shape]; line++)  
          { figure[line].x  = (int) shapes[obj[i].shape][line].length *    
                                    cos(shapes[obj[i].shape][line].angle + 
                                        obj[i].rot) * 
                                    device[player].longrangescalex;

             figure[line].y  = (int) shapes[obj[i].shape][line].length *     
             sin(shapes[obj[i].shape][line].angle + obj[i].rot) * 
                      device[player].longrangescaley; 
          }
          XDrawLines (xdisplay[player]->disp, xdisplay[player]->lrpixmap, 
                      gc, figure, numpairs[obj[i].shape], CoordModePrevious); 
        
       }
     }
   }
}

/*****************************************************************************/
/* This function is will draw an object based on the passed parameters */
DrawShape(disp, window, gc, shape, x, y, rot,player)
  Display *disp;
  Drawable window;
  GC gc;
  int shape,player; 
  double x, y, rot;
{ int line;
  extern PolarPair shapes[LASTSHAPE+1][MAXPAIRS];
  extern int numpairs[LASTSHAPE+1];
        extern PhysicalType physical[MAXPLAYERS+1];
        extern DeviceType   device[MAXPLAYERS+1];
        extern VirtualType  virtual;
  XPoint figure[MAXPAIRS];
  figure[0].x = (int) (x - physical[player].x) * device[player].scalex ; 
        figure[0].y = (int) (y - physical[player].y) * device[player].scaley ;

  for (line=1; line < numpairs[shape]; line++)  /* 2 pairs = 1 line */
  { figure[line].x  = (int) shapes[shape][line].length *    
      cos(shapes[shape][line].angle + rot) * device[player].scalex;
    figure[line].y  = (int) shapes[shape][line].length *     
      sin(shapes[shape][line].angle + rot) * device[player].scaley; 
  }
  XDrawLines (disp, window, gc, figure, numpairs[shape], CoordModePrevious); 
  
}

int myhandler(display, myerr)
Display *display;
XErrorEvent *myerr;
{
  char msg[80];
/*  XGetErrorText(display,myerr->error_code,msg,80);
  fprintf(stderr,"Error code %s\n",msg);
*/
  fprintf(stderr,"An X error has occured\nShutting down application");
  exit(1);
}

/*****************************************************************************/
/* This function will initialize the display for the passed player */
void initialize ( xdisplay, player)
  Xparam xdisplay;
  int player;


{ 
  Cursor cursor;
  Font font;
        int dummy;



  XColor black, exact;

  XSizeHints hint;
  XWMHints wmhints;

  extern PhysicalType physical[MAXPLAYERS+1];
  int screen;

/*#define DEBUG*/
#ifdef DEBUG
  dummy = XSynchronize(xdisplay->disp,1); 
#endif
  printf("Initalizing %i\n",player);
        
  XSetErrorHandler(myhandler);
  XSetIOErrorHandler(myhandler);

  screen = DefaultScreen(xdisplay->disp);
  xdisplay->bg = BlackPixel(xdisplay->disp, screen);
  xdisplay->fg = WhitePixel(xdisplay->disp, screen);


  hint.x = 150; 
  hint.y = 200; 
  hint.width = device[player].width ; 
  hint.height =  device[player].height;
  hint.flags = PPosition | PSize;
 
  device[player].width = hint.width - rightborder; 
  device[player].height = hint.height;


  xdisplay->depth = DefaultDepth (xdisplay->disp, screen);
  xdisplay->window = XCreateSimpleWindow (xdisplay->disp, 
                                          DefaultRootWindow(xdisplay->disp),
                                          hint.x, hint.y, hint.width,
                                          hint.height, 5, xdisplay->fg, 
                                          xdisplay->bg);

  xdisplay->pixmap = XCreatePixmap (xdisplay->disp, xdisplay->window, 
                                    device[player].width, 
                                    device[player].height,
                                    xdisplay->depth);

  xdisplay->lrpixmap = XCreatePixmap (xdisplay->disp, xdisplay->window, 
                                      longrangewidth, 
                                      longrangeheight,
                                      xdisplay->depth);


  XSetStandardProperties (xdisplay->disp, xdisplay->window, "sw", "sw", None,
    NULL, 0, &hint);


  xdisplay->gc = XCreateGC (xdisplay->disp, xdisplay->window, 0, 0);
  xdisplay->cloakgc = XCreateGC (xdisplay->disp, xdisplay->window, 0, 0);
        
  XSetBackground (xdisplay->disp, xdisplay->gc, xdisplay->bg);
  XSetForeground (xdisplay->disp, xdisplay->gc, xdisplay->fg);


  xdisplay->cmap = XDefaultColormap(xdisplay->disp, screen);
  XAllocNamedColor(xdisplay->disp, xdisplay->cmap, "Black", &exact, &black);


        /* Set up colors if on a color display */
        if (xdisplay->depth > 1 && xdisplay->cmap ) {
    xdisplay->redgc = XCreateGC (xdisplay->disp, xdisplay->window, 0, 0);
    xdisplay->orangegc = XCreateGC (xdisplay->disp, xdisplay->window, 0, 0);
    xdisplay->yellowgc = XCreateGC (xdisplay->disp, xdisplay->window, 0, 0);
    xdisplay->greengc = XCreateGC (xdisplay->disp, xdisplay->window, 0, 0);
    XAllocNamedColor(xdisplay->disp, xdisplay->cmap, "Yellow",
                     &exact, &xdisplay->yellow);
    XAllocNamedColor(xdisplay->disp, xdisplay->cmap, "Red", &exact,
                     &xdisplay->red);
    XAllocNamedColor(xdisplay->disp, xdisplay->cmap, "Orange", &exact,
                     &xdisplay->orange);
    XAllocNamedColor(xdisplay->disp, xdisplay->cmap, "Green", &exact,
                     &xdisplay->green);



    XSetBackground (xdisplay->disp, xdisplay->redgc, xdisplay->bg);
    XSetForeground (xdisplay->disp, xdisplay->redgc, xdisplay->red.pixel);

    XSetBackground (xdisplay->disp, xdisplay->yellowgc, xdisplay->bg);
    XSetForeground (xdisplay->disp, xdisplay->yellowgc, xdisplay->yellow.pixel);

    XSetBackground (xdisplay->disp, xdisplay->greengc, xdisplay->bg);
    XSetForeground (xdisplay->disp, xdisplay->greengc, xdisplay->green.pixel);

    XSetBackground (xdisplay->disp, xdisplay->orangegc, xdisplay-> bg);
    XSetForeground (xdisplay->disp, xdisplay->orangegc, xdisplay-> orange.pixel);
        } else {

          xdisplay -> redgc = xdisplay->gc ;
          xdisplay -> yellowgc = xdisplay->gc ;
          xdisplay -> orangegc = xdisplay->gc ;
          xdisplay -> greengc = xdisplay->gc ;

          XSetBackground (xdisplay->disp, xdisplay->cloakgc, xdisplay->bg);
          XSetForeground (xdisplay->disp, xdisplay->cloakgc, xdisplay->fg);
        }

  XSetGraphicsExposures(xdisplay->disp, xdisplay->gc, 0); 
  /* IMPORTANT!  If you do not
     specifically ask not to get Expose events, every XCopyArea
    will generate one, & the event queue will fill up.  */
  /*  font = XLoadFont(xdisplay->disp, "10x20\0");   */
  font = XLoadFont(xdisplay->disp, "fixed");


  if (!font) {
    font = XLoadFont(xdisplay->disp, "fixed");

  }
  if (!font) {
    font = XLoadFont(xdisplay->disp, "*");

  }

  XSetFont(xdisplay->disp, xdisplay->gc, font);
  XSetFont(xdisplay->disp, xdisplay->redgc, font);
  XSetFont(xdisplay->disp, xdisplay->yellowgc, font);
  XSetFont(xdisplay->disp, xdisplay->orangegc, font);
  XSetFont(xdisplay->disp, xdisplay->greengc, font);


  xdisplay->pmgc = XCreateGC (xdisplay->disp, xdisplay->window, 0, 0);

  XSetLineAttributes(xdisplay->disp, xdisplay->cloakgc,0,LineOnOffDash,
                     CapButt,JoinMiter);
  /* fg of pixmap is bg of window */
  XSetForeground (xdisplay->disp, xdisplay->pmgc, xdisplay->bg);  
  wmhints.flags = InputHint;
  wmhints.input = True;
  XSetWMHints(xdisplay->disp, xdisplay->window, &wmhints);  

  XSelectInput (xdisplay->disp, xdisplay->window,
                KeyPressMask | KeyReleaseMask | StructureNotifyMask | 
                ButtonPressMask| 
                ButtonReleaseMask);

  XMapRaised (xdisplay->disp, xdisplay->window);




  XFillRectangle (xdisplay->disp, 
                  xdisplay->pixmap, 
                  xdisplay->pmgc, 
                  0, 
                  0, 
                  device[player].width, 
                  device[player].height);

  XFillRectangle (xdisplay->disp, 
                  xdisplay->lrpixmap, 
                  xdisplay->pmgc, 
                  0, 
                  0, 
                  longrangewidth, 
                  longrangeheight);

/*DD        printf("DONE initialize"); */

}

/*****************************************************************************/
/* This function will free any memory associated with the passed xdisplay
   information and close the connect to the display */
void Shutdown ( xdisplay )

 Xparam xdisplay;
{

  XFreeGC (xdisplay->disp, xdisplay->gc);
  XFreeGC (xdisplay->disp, xdisplay->pmgc);
  XFreeGC(xdisplay->disp, xdisplay->cloakgc);
  if (xdisplay->depth > 1) {
    XFreeGC(xdisplay->disp, xdisplay->redgc);
    XFreeGC(xdisplay->disp, xdisplay->yellowgc);
    XFreeGC(xdisplay->disp, xdisplay->orangegc);
    XFreeGC(xdisplay->disp, xdisplay->greengc);
  }
  XFreePixmap (xdisplay->disp, xdisplay->pixmap);
  XFreePixmap (xdisplay->disp, xdisplay->lrpixmap);
  XDestroyWindow (xdisplay->disp, xdisplay->window);
  XCloseDisplay (xdisplay->disp);
  
}

/*****************************************************************************/
/* This function will redraw all of the objects on all of the user's short
   range scan.  The short range scan will only show the objects that are
   in the range of the scan.  Every player can have a different range of the
   scan

 */
void DrawShortRangeScan ( xdisplay ) 
  Xparam xdisplay[MAXPLAYERS+1];
{
  extern Objtype obj[LASTOBJ+1];
  extern PhysicalType physical[MAXPLAYERS+1];

  char text[30];
  int i,rx,ry,player;
  XPoint figure[5];
  
  
  /* draw ships if not cloaked */
  /*# this could be coded better !!!! */


  for (player = FIRSTPLAYER; player <= LASTPLAYER; player ++) {
    if (obj[player].alive){
      if (ship[player].cloak_on) {
         DrawShape(xdisplay[player]->disp, xdisplay[player]->pixmap, 
                   xdisplay[player]->cloakgc, 
                   obj[player].shape,
                   obj[player].x, obj[player].y, obj[player].rot,player);
        if (ship[player].shield_on) {
          rx = abs((int) (ship[player].size*device[player].scalex));
          ry = abs((int) (ship[player].size*device[player].scaley));
          
          /*# this should be common code */
          XDrawArc(xdisplay[player]->disp, 
                   xdisplay[player]->pixmap, xdisplay[player]->gc,
                   (int) ((obj[player].x - physical[player].x)*
                          device[player].scalex) - rx,
                   (int) ((obj[player].y - physical[player].y)*
                          device[player].scaley) - ry,
                   2*rx, 2*ry, 0, 360*64);
        }
      }
      else {
        
        for ( i = FIRSTPLAYER; i <= LASTPLAYER; i ++){  
          /* i is the iterator for each display */
          
          if ( i == player) {
            DrawShape(xdisplay[i]->disp, 
                      xdisplay[i]->pixmap, xdisplay[i]->greengc, 
                      obj[player].shape,obj[player].x, 
                      obj[player].y, obj[player].rot,i);
          }
          else{
            DrawShape(xdisplay[i]->disp, 
                      xdisplay[i]->pixmap, xdisplay[i]->yellowgc, 
                      obj[player].shape,obj[player].x, obj[player].y, 
                      obj[player].rot,i);
          }

          if (ship[player].shield_on && obj[player].alive) {
            /*      printf("Drawing Shield %i on screen %i\n ",player,i); */
            rx = abs((int) (ship[player].size*device[i].scalex));
            ry = abs((int) (ship[player].size*device[i].scaley));

            /*# this should be common code */
            XDrawArc(xdisplay[i]->disp, xdisplay[i]->pixmap, xdisplay[i]->gc,
                   (int) ((obj[player].x - physical[i].x)*device[i].scalex) - rx,
                   (int) ((obj[player].y - physical[i].y)*device[i].scaley) - ry,
                   2*rx, 2*ry, 0, 360*64);
            
          }/*if time to draw shield */
          
        }
        
      }
    }
  }
  
  for (player =FIRSTPLAYER; player <= LASTPLAYER; player++){
    /*## no scroll */
    /* draw the edge of the virtual window */
    figure[0].x = (int)((virtual.x1 - physical[player].x)*device[player].scalex);
    figure[0].y = (int)((virtual.y1 - physical[player].y)*device[player].scaley);
    
    figure[1].x = (int)((virtual.x2 - physical[player].x)*device[player].scalex);
    figure[1].y = figure[0].y;
    
    figure[2].x = figure[1].x;
    figure[2].y = (int)((virtual.y2 - physical[player].y)*device[player].scaley);
    
    figure[3].x = figure[0].x;
    figure[3].y = figure[2].y;
    
    figure[4].x = figure[0].x;
    figure[4].y = figure[0].y;
    
    XDrawLines(xdisplay[player]->disp, 
               xdisplay[player]->pixmap, 
               xdisplay[player]->gc,
               figure,
               5,
               CoordModeOrigin);
    if (!obj[player].alive && !obj[player].blowingup ) {
      
      
      boom(player, BMAX-1, 70);
      obj[player].blowingup = 1;
      XBell( xdisplay[player]->disp,-1);
      
    }/* if player not alive */
    
    
    
    /*  Draw objects  */
    for (i = LASTPLAYER + 1; i <= LASTOBJ; i++)
      if (obj[i].alive){
        
        DrawShape(xdisplay[player]->disp, xdisplay[player]->pixmap, 
                  xdisplay[player]->gc, 
                  obj[i].shape,obj[i].x, obj[i].y, obj[i].rot,player);
        
      }
    
    
    drawbooms(xdisplay[player]->disp, 
              xdisplay[player]->pixmap, xdisplay[player]->yellowgc,
              xdisplay[player]->redgc,xdisplay[player]->orangegc,player);
    
    DrawLongRangeScan (xdisplay,player);
    /* update display:  */
    XCopyArea(xdisplay[player]->disp, 
              xdisplay[player]->pixmap,
              xdisplay[player]->window, 
              xdisplay[player]->gc, 
              0, 
              0, 
              device[player].width, 
              device[player].height, 
              0, 
              0);
    
    XCopyArea(xdisplay[player]->disp, 
              xdisplay[player]->lrpixmap,
              xdisplay[player]->window, 
              xdisplay[player]->gc, 
              0,
              0, 
              longrangewidth, 
              longrangeheight, 
              device[player].width + 2, 
              1);

    DrawShipStatus(player,xdisplay[player]);
    /* erase objects  */
    XFillRectangle (xdisplay[player]->disp, 
                    xdisplay[player]->pixmap, 
                    xdisplay[player]->pmgc, 
                    0, 
                    0, 
                    device[player].width, 
                    device[player].height);
    

    XFillRectangle (xdisplay[player]->disp, 
                    xdisplay[player]->lrpixmap, 
                    xdisplay[player]->pmgc, 
                    0, 
                    0, 
                    longrangewidth, 
                    longrangeheight);
    

  } /*end playerloop */

/* The multisync has been causing segmentation faults at radom intervals */
#define MULTISYNC 
#ifdef MULTISYNC 
  XMultiSync(dpys,LASTPLAYER-FIRSTPLAYER     + 1, 0);   
  
#else
      for (player = FIRSTPLAYER; player <= LASTPLAYER; player++){
        XSync(xdisplay[player]->disp,0);
        }
#endif
}
